﻿// Author: Moreno Sint Hill alias Mirabis
// Created on: 21/04/2015 21:28
// Last Edited on: 21/04/2015 21:29
// File: DelzaHotspots.DelzaHotspots.DelszaHotspots.cs
// Copyright:  2015, Moreno Sint Hill - All rights reserved.
// 
// ALL CONTENTS IN THIS PROJECT ARE PROTECTED BY COPYRIGHT. EXCEPT AS SPECIFICALLY PERMITTED HEREIN, 
// NO PORTION OF THE INFORMATION IN THIS PROJECT MAY BE REPRODUCED IN ANY FORM, OR BY ANY MEANS, WITHOUT PRIOR WRITTEN PERMISSION FROM MORENO SINT HILL <moreno@sinthill.nl>. 
// IT IS NOT PERMITTED TO MODIFY, DISTRIBUTE, PUBLISH, TRANSMIT OR CREATE DERIVATIVE WORKS OF ANY MATERIAL FOUND IN THIS PROJECT FOR ANY PUBLIC OR COMMERCIAL PURPOSES.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.Windows.Input;
using Styx;
using Styx.Common;
using Styx.Plugins;

namespace DellzaHotspots
{
    public class DellszaHotspots : HBPlugin
    {
        /// <summary>
        ///     The name of this plugin.
        /// </summary>
        /// <value>
        ///     The name.
        /// </value>
        public override string Name
        {
            get { return "DellzaHotspots"; }
        }

        /// <summary>
        ///     The author of this plugin.
        /// </summary>
        /// <value>
        ///     The author.
        /// </value>
        public override string Author
        {
            get { return "Mirabis"; }
        }

        /// <summary>
        ///     The version of the plugin.
        /// </summary>
        /// <value>
        ///     The version.
        /// </value>
        public override Version Version
        {
            get { return new Version(1,0,0); }
        }

        /// <summary>
        ///     Called everytime the engine pulses.
        /// </summary>
        public override void Pulse()
        {
            if (AreAllKeysDown(new[] { Keys.D1,Keys.ShiftKey}))
            {
                var loc = StyxWoW.Me.Location;
                Logging.Write("<Hotspot Name=\"{3}\" X=\"{0}\" Y=\"{1}\" Z=\"{2}\" />", loc.X, loc.Y, loc.Z, StyxWoW.Me.SubZoneText);
            }
        }


#region Extensions
        /// <summary>
        ///     KEYSTATE function.
        /// </summary>
        /// <param name="keyCode">
        /// </param>
        /// <returns>
        ///     The <see cref="short" />.
        /// </returns>
        [DllImport("user32.dll", CharSet = CharSet.Auto, ExactSpelling = true)]
        private static extern short GetAsyncKeyState(int keyCode);

        /// <summary>
        ///     The get key state.
        /// </summary>
        /// <param name="key">
        ///     The key.
        /// </param>
        /// <returns>
        ///     The <see cref="KeyStates" />.
        /// </returns>
        private static KeyStates GetAsyncKeyState(Keys key)
        {
            var state = KeyStates.None;

            short retVal = GetAsyncKeyState((int)key);
            if ((retVal & 0x8000) == 0x8000) state |= KeyStates.Down;

            return state;
        }

        /// <summary>
        ///     The is key down.
        /// </summary>
        /// <param name="key">
        ///     The key.
        /// </param>
        /// <returns>
        ///     The <see cref="bool" />.
        /// </returns>
        internal static bool IsKeyDown(Keys key)
        {
            if (key == Keys.None) return false;
            Keys keyCode = key & Keys.KeyCode;
            int mods = 0;
            var modds = new List<Keys>();

            if ((key & Keys.Shift) != 0)
            {
                mods += 1;
                modds.Add(Keys.ShiftKey);
            }

            if ((key & Keys.Alt) != 0)
            {
                mods += 1;
                modds.Add(Keys.Menu);
            }

            if ((key & Keys.Control) != 0)
            {
                mods += 1;
                modds.Add(Keys.ControlKey);
            }
            return mods != 0
                       ? modds.TrueForAll(k => (KeyStates.Down == (GetAsyncKeyState(k) & KeyStates.Down))) && KeyStates.Down == (GetAsyncKeyState(keyCode) & KeyStates.Down)
                       : KeyStates.Down == (GetAsyncKeyState(keyCode) & KeyStates.Down);
        }

        internal static bool IsAnyKeyDown(IEnumerable<Keys> key)
        {
            return key.Any(IsKeyDown);
        }

        internal static bool AreAllKeysDown(IEnumerable<Keys> key)
        {
            return key.All(IsKeyDown);
        }
#endregion
    }
}